# TSDS - TypeScript Data Structures

## A collection of TypeScript classes to create and use common data structures

### Installing

 ```
 npm install typescript-data-structures
 ```
### General Usage
Import the desired data structure in your file

```
import { LinkedList } from 'typescript-data-structures'
```

Instantiate class 

```
private linkedList: LinkedList = new LinkedList();
```

Use class methods

```
this.linkedList.addToHead('new head');
```
### Data Structures

![](https://img.shields.io/badge/Linked%20List%20-%20%20%E2%9C%94%20%20-brightgreen.svg)
![](https://img.shields.io/badge/Binary%20Search%20Tree%20-%20%20in%20progress%20%20-yellowgreen.svg)
![](https://img.shields.io/badge/Hash%20Table-%20%20planned%20%20-yellow.svg)

### API
Find a short reference to each structure's public methods in src/[structure]/README.md

### Contributing

Contributing rules will follow
### Versioning

We use [SemVer](http://semver.org/) for versioning. For the versions available, see the [tags on this repository](https://github.com/RCMiron/TSDS/tags). 

### Authors

[Radu Miron](https://github.com/RCMiron),
[Iacob Nasca](https://github.com/cthackers),
[Cosmin Serboteiu](https://github.com/Annno)

### Aknowledgements

[Eric Traub - Data Structures in Javascript](https://www.udemy.com/learning-data-structures-in-javascript-from-scratch)

### License

This project is licensed under the MIT License - see the [LICENSE.md](LICENSE.md) file for details

