"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Tree = /** @class */ (function () {
    function Tree() {
    }
    return Tree;
}());
exports.Tree = Tree;
var BinarySearchTree = /** @class */ (function () {
    function BinarySearchTree(value, condition, compareField) {
        this.value = value;
        this.condition = condition;
        this.compareField = compareField;
        this._left = null;
        this._right = null;
    }
    Object.defineProperty(BinarySearchTree.prototype, "left", {
        get: function () {
            return this._left;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BinarySearchTree.prototype, "right", {
        get: function () {
            return this._right;
        },
        enumerable: true,
        configurable: true
    });
    BinarySearchTree.prototype.setInsertCondition = function (cb) {
        this.compareField = null;
        this.condition = cb;
    };
    BinarySearchTree.prototype.setCompareField = function (compareField) {
        if (compareField !== null && this.value.hasOwnProperty(compareField)) {
            this.compareField = compareField;
            this.condition = null;
        }
    };
    BinarySearchTree.prototype.insert = function (value) {
        if (value === Object(value) && !this.condition && !this.compareField) {
            try {
                throw new Error('To insert non-primitive values, first setInsertCondition or setCompareField');
            }
            catch (e) {
                console.error(e);
            }
            return;
        }
        else if (value !== Object(value) && !this.condition && !this.compareField) {
            this.condition = function (val) {
                return val > this.value;
            };
        }
        else if (!this.condition && this.compareField) {
            this.condition = function (val) {
                return val[this.compareField] > this.value[this.compareField];
            };
        }
        if (!this.condition(value)) {
            if (!this._left) {
                this._left = new BinarySearchTree(value, this.condition, this.compareField);
            }
            else {
                this._left.insert(value);
            }
        }
        else {
            if (!this._right) {
                this._right = new BinarySearchTree(value, this.condition, this.compareField);
            }
            else {
                this._right.insert(value);
            }
        }
    };
    BinarySearchTree.prototype.traverseDepth = function (cb, order) {
        if (order && order === 'preOrder') {
            cb(this.value);
        }
        if (this.left) {
            this._left.traverseDepth(cb, order);
        }
        if (!order || order === 'inOrder') {
            cb(this.value);
        }
        if (this.right) {
            this._right.traverseDepth(cb, order);
        }
        if (order && order === 'postOrder') {
            cb(this.value);
        }
    };
    return BinarySearchTree;
}());
exports.BinarySearchTree = BinarySearchTree;
