"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var LinkedListNode = /** @class */ (function () {
    function LinkedListNode(value, next, prev) {
        this.value = value;
        this.next = next;
        this.prev = prev;
    }
    return LinkedListNode;
}());
exports.LinkedListNode = LinkedListNode;
var LinkedList = /** @class */ (function () {
    function LinkedList() {
        this._head = null;
        this._tail = null;
    }
    Object.defineProperty(LinkedList.prototype, "head", {
        get: function () {
            return this._head;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LinkedList.prototype, "tail", {
        get: function () {
            return this._tail;
        },
        enumerable: true,
        configurable: true
    });
    LinkedList.prototype.addToHead = function (value) {
        var newNode = new LinkedListNode(value, this._head, null);
        if (this._head) {
            this._head.prev = newNode;
        }
        else {
            this._tail = newNode;
        }
        this._head = newNode;
    };
    LinkedList.prototype.addToTail = function (value) {
        var newNode = new LinkedListNode(value, null, this._tail);
        if (this._tail) {
            this._tail.next = newNode;
        }
        else {
            this._head = newNode;
        }
        this._tail = newNode;
    };
    LinkedList.prototype.removeHead = function () {
        if (!this._head) {
            return null;
        }
        var val = this._head.value;
        this._head = this._head.next;
        if (this._head) {
            this._head.prev = null;
        }
        else {
            this._tail = null;
        }
        return val;
    };
    LinkedList.prototype.removeTail = function () {
        if (!this._tail) {
            return null;
        }
        var val = this._tail.value;
        this._tail = this._tail.prev;
        if (this._tail) {
            this._tail.next = null;
        }
        else {
            this._head = null;
        }
        return val;
    };
    LinkedList.prototype.has = function (value) {
        var currentNode = this._head;
        while (currentNode) {
            if (currentNode.value === value) {
                return currentNode;
            }
            currentNode = currentNode.next;
        }
        return null;
    };
    LinkedList.prototype.search = function (value) {
        var currentNode = this._head;
        var result = [];
        while (currentNode) {
            if (currentNode.value === value) {
                result.push(currentNode);
            }
            currentNode = currentNode.next;
        }
        return result.length ? result : null;
    };
    return LinkedList;
}());
exports.LinkedList = LinkedList;
